/*
    Fluid movement digital filter implementation.
    Copyright (C) 2017  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __FLUID_H
#define __FLUID_H	1


/***************************************************************************/
/* define pubblici */

#define FLUID_FILTER_STEPS	60

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

typedef signed long int		FluidData_t;

typedef struct
{
  float		In[2+1];
  float		Out[2+1];
}FluidFilter_t;

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

void ResetFluidFilter(FluidFilter_t *Filter);
  /* Resetta gli stati interni del filtro. */

FluidData_t FluidFilter_1(FluidFilter_t *Filter,FluidData_t Input);
  /* Fluid digital filter: smussa il movimento senza sovraelongazione. */

FluidData_t FluidFilter_2(FluidFilter_t *Filter,FluidData_t Input);
  /* Fluid digital filter: smussa il movimento con sovraelongazione. */

/***************************************************************************/
#endif

/* $Source$ */

