/*
    Random eye sector generator.
    Copyright (C) 2017  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */


/***************************************************************************/
/* include vari */

#define __RANDOM_C
#include "random.h"				// functions prototypes

/***************************************************************************/
/* define interni alla libreria */

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* variabili interne alla libreria */

/***************************************************************************/
/* funzioni interne alla libreria */

static unsigned long int Random(void);
  /* Ritorna un valore random a 32 bit. */

/***************************************************************************/
/* funzioni */

static unsigned long int Random(void)
{
  /* Ritorna un valore random a 32 bit. */



  static unsigned long int	Shift=1;	// shift register
  unsigned long int		Tap1,Tap2,Tap3;



  // salva il valore dei tap
  Tap1=(Shift & (1<< 0)) << 31;
  Tap2=(Shift & (1<<30)) << 1;
  Tap2=(Shift & (1<<17)) << 14;
  Shift>>=1;					// shift del registro
  Shift|=Tap1 ^ Tap2 ^ Tap3;			// retroazione
  return(Shift);				// termina
}



void RandomSector(const MagicEye_t *EyeDesc,int v)
{
  /* Aggiorna i primi 32 pixel della riga v-esima del magic eye indicato. */



  unsigned long int	Mask;
  int			i;
  Color_t		Color;



  Mask=Random();				// ottiene la nuova maschera
  for(i=0;i<32;i++)
  {
    if(Mask & 0x0001)
      Color=0xffff;				// bianco
    else
      Color=0x0000;				// nero
    MagicEye_PutPixel(EyeDesc,i,v,Color);	// colora il pixel
    Mask>>=1;					// next mask bit
  }
  return;					// termina
}

/* $Source$ */

